--[[
Name: AlarAddon-3.0
Revision: $Rev: 346 $
Author: Alar of Daggerspine
Email: alar@aspide.it
Website: http://wow.aspide.it
SVN: $HeadUrl:$
Description: Generic library
Dependencies: Ace3
License: LGPL v2.1
--]]
local MAJOR_VERSION ="AlarAddon-3.0"
local MINOR_VERSION = tonumber(string.sub("$Revision: 346 $", 12, -3))
local function pp(msg) -- Minimal output function
    if (not ALARDEVELOPMENTPC) then return end
    DEFAULT_CHAT_FRAME:AddMessage("c0000ff00pp->|r" .. tostring(msg),1,0.5,0.2)
end
local __FILE__=tostring(debugstack(1,2,0):match("(.*):1"))
if (ALARDEVELOPMENTPC) then
DEFAULT_CHAT_FRAME:AddMessage(MAJOR_VERSION .. " from file " .. __FILE__)
end
pp("Loading " .. MAJOR_VERSION .. " r" .. MINOR_VERSION)
if (not LibStub) then
    DEFAULT_CHAT_FRAME:AddMessage("Couldn't find LibStub. Please reinstall " .. MAJOR_VERSION )
end
local lib,old=LibStub:NewLibrary(MAJOR_VERSION,MINOR_VERSION)
if (not lib) then
    pp("Already loaded a newer or equal version of " .. MAJOR_VERSION)
    return -- Already loaded
end
if (old) then
    pp(format("Upgrading %s from %s to %s",MAJOR_VERSION,old,MINOR_VERSION))
end

-- I hate having to do the same thing a lot of times... so here is my stub
-- It calls LibStub and returns an addon with all available ace3 embeddable
-- components mixed in

function AlarLittlePrintUtility(...) -- Minimal output function
    if (not ALARDEVELOPMENTPC) then return end
    msg=''
	for i=1, select("#", ...) do
		msg = msg .. tostring( select( i, ...) ) .." "
	end    
    DEFAULT_CHAT_FRAME:AddMessage("|c0000ff00pp->|r" .. tostring(msg),1,0.5,0.2)
end
local pp=AlarLittlePrintUtility
function lib:new(name,...)
    local mixins={}
    for i,k in  LibStub:IterateLibraries() do
        if (i:match("Ace%w*-3%.0") and k.Embed) then
            table.insert(mixins,i)
        end
    end
    table.insert(mixins,"AlarCore-3.0")
    for i=1,select('#',...) do
        table.insert(mixins,(select(i,...)))
    end
    local stub=LibStub("AceAddon-3.0"):NewAddon(name,unpack(mixins))
    stub.Dump=stub.Print
    local ace=LibStub("AceConsole-2.0",true)
    if (ace) then
        stub.Print=ace.Print
        stub.Dump=ace.PrintLiteral
    else
        ace=LibStub("LibRockConsole-2.0",true)
        if (ace) then
            stub.Print=ace.Print
            stub.Dump=ace.PrintLiteral
        end
    end
    return stub
    
end
